/*
file name: K++.cpp
author:    Jorge Cervantes
e-mail:    JorgeCervantesO@netscape.net
robot:     K++

  This robot is designed to race in ANY track so I wish to race
it in ALL upcomming races.

  The code is NOT confidential.

*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
//#include <dos.h>
#include <iostream.h>
#include "car.h"
#include "os.h"
#include "misc.h"
#include "track.h"

#ifndef TRUE
# define TRUE 1
#endif
#ifndef FALSE
# define FALSE 0
#endif

static double BRAKE_ACCEL = -40;      // acceleration when braking on straight
static double BRK_CRV_ACC = -35;      // acceleration when braking in curve

static double 
        last_damage = 0.0,
        lap_damage  = 0.0;

static situation s;
static con_vec r1,r2;                    // This is what is returned.

static int sign( double x )
{ return x==0?0:(x<0?-1:1); }

static double ending_speed( double Vo, double x, double a, double &e_d )
{
  double t, Vf;

  e_d = x;

  //  x = Vo*t + a*t*t/2
  if( Vo*Vo < 4.0*a/2.0*(-x) )
  {
    t = - Vo/a;
    e_d = Vo*t + a*t*t/2;
    return 0.0;
  }

  t = (-Vo+sqrt(Vo*Vo-4.0*a/2.0*(-x))) / (2.0*a);

  Vf = Vo + a*t;

  return Vf;
}

static int closest()
{ int   min_i=-1;
  const double k=2;
  double min_d=sqrt(2.0)*k*CARLEN,d;
  for( int i=0; i<16; i++ )
    if( s.nearby[i].who >= 0 
        && 
        s.nearby[i].who < 16
      )
    {
      d=sqrt( s.nearby[i].rel_x * s.nearby[i].rel_x 
            + s.nearby[i].rel_y * s.nearby[i].rel_y
            );
      if( d < min_d )
      {
        min_d = d;
        min_i = i;
      }
    } 
    else
      break;

  return min_i;
}

static int consider_nearby( int i,
          double max_dot,
//          int n,
          double min_vsqr,
          double max_time
//          double x_factor,
//          double y_factor
        )
{
  double y,x,vy,vx,dot,vsqr,c_time,x_close,y_close,theta,separation;
  y=s.nearby[i].rel_y;         // get forward distance (center-to-center)
  x=s.nearby[i].rel_x;         // get right distance
  vx=s.nearby[i].rel_xdot;     // get forward relative speed
  vy=s.nearby[i].rel_ydot;     // get lateral relative speed

  separation = sqrt( (fabs(x)-CARWID)*(fabs(x)-CARWID)
                     +
                     (fabs(y)-CARLEN)*(fabs(y)-CARLEN)
                   );

  min_vsqr < 0.1 ? min_vsqr = 0.1 : 0;

  // if behind then ignore it.
//  if( y < 0 )
//    return 0;
/*
  if( //s.damage > last_damage
      //&&
      //y > 0
      //&&
      y < CARLEN
      &&
      fabs(x) < CARWID
    )
    return y>0;
*/
  // if the cars are getting closer, then the dot product of the relative
  // position and velocity vectors will be negative.
  dot = x * vx + y * vy;     // compute dot product of vectors
  if(dot > max_dot)            // no action if car is not approaching (fast).
    return 0;

  vsqr = vx*vx + vy*vy;      // compute relative speed squared

  // Brake if too much danger
  double v = sqrt(vsqr),
        mv = min_vsqr<25?min_vsqr:25,
        a  = BRK_CRV_ACC,
         e_s,d;
  e_s = ending_speed(v+mv,separation,a,d);
//  if( v>sqrt(-2*a*separation) )
//    v=v;
  if( ( s.nearby[i].to_rgt > -CARWID*2.0
        &&
        s.nearby[i].to_lft > -CARWID*2.0
        ||
        sign( s.nearby[i].vn ) == sign( s.nearby[i].to_lft )
      )
      && 
      y > CARLEN
    )
  { //if( v > sqrt(-2*a*separation) )        
    //  return 1;
    //if( vy < -5-mv )
    //  return 1;
    //if( v > 80 )
       //return 1;
    if( e_s > separation+mv*CARLEN/y )
    {
//      if( e_s > y+mv*CARLEN/y )
//        result.alpha *= 0.1;
      if( e_s > 25 
          && 
          sign(x) != sign(vx) 
          &&
          sign(r1.alpha) != sign(x)
        )
        r1.alpha = 0;//fabs(result.alpha)*sign(x);//-1;
      return 1; //e_s = e_s;
    }
  }

//  return 0;

  if( vsqr < 0.1)//min_vsqr )
    return 0;

//  if( vy < -10-min_vsqr )
//    return 1;

  // Time to closest approach is dot product divided by speed squared:
  c_time = -dot / vsqr;     // compute time to closest approach
  if(c_time > max_time)         // ignore if over three seconds
     return 0;

  /* If the execution gets this far, it means that there is a car
  ahead of you, and getting closer, and less than 3.0 seconds
  away.  Evaluate the situation more carefully to decide if
  evasive action is warranted: */
  //if( s.nearby[i].braking )
  //  acc = -BRAKE_ACCEL;      // for at^2/2
  x_close = x + c_time * vx;// + c_time*c_time*acc*vx/(2*vx);  // x coord at closest approach
  y_close = y + c_time * vy;// + c_time*c_time*acc*vy/(2*vy);  // y coord at closest approach
  if( y_close < CARLEN/2. )
    return 0;

  /*  Due to the length of the cars, a collision will occur if
      x changes sign while y is less than CARLEN.  This
      can happen before the center-to-center distance reaches its
      point of closest approach. */
  // check if collision would occur prior to closest approach
  // if so, reduce c_time, re-calculate x_close and y_close:
  if(x_close * x < 0.0 && y < CARLEN ) {
     if( fabs( vx ) < 0.1 )
       return 0;
     c_time = (fabs(x) - CARWID ) / fabs(vx);
     x_close = x + c_time * vx;      // x coord at closest approach
     y_close = y + c_time * vy;      // y coord at closest approach
     if( y_close < CARLEN/2. )
       return 0;
  }
  // Will it be a hit or a miss?
  theta = s.nearby[i].alpha; 
      //- s.alpha;
  if( !collide( x_close, y_close, theta ))
    if( fabs(x_close)>CARWID
        ||
        fabs(y_close)>CARLEN
      )
      return 0;

   x=1;
/*
  if(fabs(x_close) > x_factor * CARWID * caution_factor( 1 )
     ||
     fabs(y_close) > y_factor * CARLEN * caution_factor( 1 ))
     return 0;            // this when a miss is predicted
*/

  return 1;
}

static int most_dangerous( float *danger, float *v )
{ float max=0;
  int k=0;
  for( int i=0; i<16; i++)
    if( danger[i]*v[i] > max )
    { max=danger[i]*v[i];
      k=i;
    }
  return k;
}

static int apply_brakes()
{
  #define VL 0.01f
  int i,apply=0;
//  static int init=0;
  static float v[16]=        {VL,  VL,  VL,  VL,  VL,  VL,  VL,  VL,  VL,  VL,  VL,  VL,  VL,  VL,  VL,  VL  };
  static float d[16]=        {0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f},
               a_damage[16]= {0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f},
               t_damage[16]= {0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f},
               n[16]=        {0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f,0.0f};

  if( s.damage > last_damage )
  do
  {
    lap_damage += s.damage - last_damage;
  
    if( (i = closest()) < 0 )
      break;

    if( (v[s.nearby[i].who] -= 0.5f) < 0.1f )
      v[s.nearby[i].who] = 0.1f;

    a_damage[s.nearby[i].who] *= n[s.nearby[i].who]++;
    a_damage[s.nearby[i].who] += float( s.damage - last_damage );
    a_damage[s.nearby[i].who] /= n[s.nearby[i].who];

    t_damage[s.nearby[i].who] += float( s.damage - last_damage );
  }while(0);

  for( i=0; i<NEARBY_CARS; i++ )
  {
    if( s.nearby[ i ].who >= 16 
        ||
        s.nearby[ i ].who < 0 
      )
      break;

//    if( i == 3 )
//      apply |= 1;

    v[s.nearby[i].who] += 0.001f;
    
    if( 0 == strcmp( drivers[s.nearby[ i ].who]->getName(), "K++Mate")
        ||
        s.nearby[ i ].rel_y < 3*CARLEN
			  &&
				s.nearby[ i ].rel_x < 1.5*CARWID
        ||
        //s.nearby[ i ].v > s.v
        //||
        !consider_nearby( i, -0.1, //1, 
                          pow( 2,//*s.nearby[i].rel_y/CARLEN,
                               1+v[s.nearby[i].who]
                             )
                          // /(i/10.+1)
                          , 3 )//, 1, 1 )
      )
      continue;
    

    // If we get here there is a collision predicted
//    d[s.nearby[i].who] += 0.1f;
//    v[s.nearby[i].who] += 0.1f;

    if( s.bestlap_speed != 0.0 )
    {
      double l = get_track_description().length;
      double lost_time = s.lap_time - l/s.bestlap_speed;
      if( lap_damage*0.005+1 < lost_time )
      {
        d[s.nearby[i].who] += 0.1f;
        v[s.nearby[i].who] += 0.01f;
      }
    }

    apply |= 1;
  };

  if( s.lap_flag )
  { lap_damage = 0.0;
    for( i=0; i<16; i++)
    {
      if( d[i] == 0.0f )
      { 
//        if( v[i] < VL )
//          v[i] = VL;
      };
      d[i] = 0.0f;
    }
  }

  if( !apply )
  { 
    int 
    m=most_dangerous(a_damage,v);
    v[m] *= 0.99993f;
    //if(( v[m] *= 0.99993f ) < VL )
    //  v[m]=VL;
    m=most_dangerous(t_damage,v);
    v[m] *= 0.99993f;
    //if(( v[m] *= 0.99993f ) < VL )
    //  v[m]=VL;
    m=most_dangerous(n,v);
    v[m] *= 0.99993f;
    //if(( v[m] *= 0.99993f ) > 50.0f )
    //  v[m]=50.0f;
  }

  return apply;
}

static void request_pit()
{ 
  r1.request_pit = 0;
  r1.fuel_amount = MAX_FUEL;
  r1.fuel_amount -= s.fuel;

  double l = get_track_description().length / 5280.; // in miles
  if( s.stage == QUALIFYING )
  {
    if( s.starting )
      r1.fuel_amount = 4*l;
    return;
  }
  
  static int last_pit_lap = -1;
  static double last_pit_damage = 0,
                last_lap_damage=0,
                max_lap_damage=7500,
                last_lap_fuel=MAX_FUEL,
                fuel_to_pit=0;
  double     damage_per_gl,
             gl_to_end,
             damage_to_end;
  int pits_to_end;

  r1.request_pit = 0;

  if( s.out_pits == 1 )
  {
    last_pit_lap = s.laps_done;
    last_pit_damage = s.damage;
    fuel_to_pit = 0;
  }

  if( s.lap_flag )
  {
    double delta = s.damage - last_lap_damage;
    last_lap_damage = s.damage;
    if( delta > max_lap_damage )
    {
      max_lap_damage = delta;
      if( max_lap_damage > 7500 )
        max_lap_damage = 7500;
    }
    last_lap_fuel = s.fuel;
  }

  if( s.fuel_mileage == 0.0 )
    s.fuel_mileage = 1.0;

  damage_per_gl = ( s.damage - last_pit_damage )/( MAX_FUEL - s.fuel );
  gl_to_end = (s.laps_to_go+5) * l / s.fuel_mileage;
  damage_to_end = damage_per_gl * gl_to_end;

  r1.fuel_amount = gl_to_end - s.fuel;

  if( s.laps_done > 2 )
  {
    pits_to_end = int(gl_to_end/MAX_FUEL);
    static int last_pits_to_end=pits_to_end;
    if( pits_to_end < last_pits_to_end )
      fuel_to_pit = s.fuel/(pits_to_end+2);

    last_pits_to_end = pits_to_end;
  }

  r1.repair_amount = 0;
  if( s.damage > 30000-max_lap_damage-damage_to_end )
    r1.repair_amount = int(( s.damage - (30000-max_lap_damage-damage_to_end) )  );

  if( s.damage > 30000 - max_lap_damage
      ||
      s.damage > 30000 - 2*max_lap_damage
      &&
      s.laps_to_go > 1
      &&
      s.laps_done > last_pit_lap
      &&
      ( s.damage - last_pit_damage ) / ( s.laps_done - last_pit_lap )
      >
      (30000.-max_lap_damage-s.damage) / s.laps_to_go
    )
    r1.request_pit = 1;

  if( s.fuel_mileage > 0.0
      &&
      s.fuel * s.fuel_mileage / l < 2 // less than 2 laps
    )
    r1.request_pit = 1;
  
//  if( s.fuel < fuel_to_pit )
//    result.request_pit = 1;

  if( s.laps_to_go <= 1 )
    r1.request_pit = 0;
}

extern con_vec Kpp1( situation &s );
extern con_vec Kpp2( situation &s );

con_vec Kpp( situation &ss )
{
   const char name[] = "K++";    // This is the robot driver's name!
   static int init_flag = 1;          // cleared by first call

   s = ss;

   if(init_flag == 1)  {  // first time only, copy name
      my_name_is(name);        // copy the name string into the host program
      init_flag          =
      r1.request_pit     = 0;
      r1.vc              = 100;
      r1.alpha           =
      s.v                =
      s.out_pits         =
      ss.out_pits        = 0;
      s.side_vision      = 1;
      r1 = Kpp1( s );
      r2 = Kpp2( s );

      return r1;
   }

   r1 = Kpp1( s );
   r2 = Kpp2( s );

   static int c2=0;
   static int hard_braking=FALSE;

   if( s.nearby[0].who != 999 // someone nearby
       &&
       s.nearby[0].rel_y < 1.5*CARLEN  // very close
     )
   {
     if( //s.nearby[0].v < s.v-1 // he goes slower
         //&&
         strcmp(drivers[s.nearby[0].who]->getName(), "K++Mate")  // is not K++Mate
         &&
         (
           s.tan_a > g*0.7 // too slow
           ||
           fabs( s.cen_a ) < 0.01*g  // on straight line
           ||
           (
             s.nearby[0].rel_y < 1.5*CARLEN  // overtaking
             ||
             !strcmp(drivers[s.nearby[0].who]->getName(), "K2001")  // is K2001
             &&
             s.nearby[0].rel_y < 1.5*CARLEN  // very close
           )
           &&
           fabs( r1.alpha-r2.alpha ) < 0.01 // can change trajectory
           &&
           fabs( r1.vc-r2.vc ) < 0.1        // can change trajectory
         )
       )
       hard_braking = TRUE;//= max_ticks-wait_ticks; // change trajectory

     c2=0;
   }
   else
   {
     if( fabs( s.cen_a ) < 0.01*g  // on straight line
         ||
         fabs( r1.alpha-r2.alpha ) < 0.01 // can change trajectory
         &&
         fabs( r1.vc-r2.vc ) < 0.1          // can change trajectory
       )
       c2++;
     else
       c2=0;

     if( c2>=5 )  // can change trajectory 6 consecutive times
       hard_braking = FALSE;//= (max_ticks-wait_ticks); // change trajectory
   }

   if( hard_braking )
     r1 = r2;

   if( apply_brakes() )
     if( r1.vc > s.v - 10.0 )
       r1.vc = s.v - 10.0;

   if( s.to_lft < -0.5*CARWID
       ||
       s.to_lft < -0.5*CARWID
     )
     r1.vc *= 0.9; // offroad drive slower

   if( r1.vc < 5 )
     r1.vc = 5; // too slow

//   if( s.damage > last_damage + 100 )
//     if( sign(r1.alpha) != sign(s.to_rgt))
//       r1.alpha *= 2;

//   request_pit();

   last_damage = s.damage;

   return r1;
}
